/*
 * Copyright (c) 2019 AlexIIL
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */
package alexiil.mc.lib.multipart.impl;

import java.util.function.Predicate;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import net.fabricmc.api.ModInitializer;
import net.fabricmc.fabric.api.object.builder.v1.block.FabricBlockSettings;
import net.fabricmc.fabric.api.object.builder.v1.block.entity.FabricBlockEntityTypeBuilder;
import net.minecraft.class_1937;
import net.minecraft.class_2378;
import net.minecraft.class_2591;
import net.minecraft.class_2960;
import net.minecraft.class_3614;
import net.minecraft.class_3620;
import alexiil.mc.lib.multipart.api.misc.FloatSupplier;

public class LibMultiPart implements ModInitializer {

    public static final String NAMESPACE = "libmultipart";
    public static final Logger LOGGER = LogManager.getLogger(NAMESPACE);
    public static final boolean DEBUG = Boolean.getBoolean("libmultipart.debug");

    public static final MultipartBlock BLOCK;
    public static final class_2591<MultipartBlockEntity> BLOCK_ENTITY;

    static Predicate<class_1937> isWorldClientPredicate = w -> false;
    static FloatSupplier partialTickGetter = () -> 1;

    static {
        if (DEBUG) {
            LOGGER.info(
                "Debugging enabled for LibMultiPart - you can disable it by adding '-Dlibmultipart.debug=false' to your launch args"
            );
        } else {
            LOGGER.debug(
                "Debugging not enabled for LibMultiPart - you can enable it by adding '-Dlibmultipart.debug=true' to your launch args"
            );
        }

        class_3614 material = new class_3614.class_3615(class_3620.field_16009).method_15813();
        BLOCK = new MultipartBlock(
            FabricBlockSettings.method_9637(material)//
                .method_16229()//
                .breakByHand(true)//
                .method_36557(0.5f)//
                .method_36558(2.0f)//
                .method_9624()//
                .method_9631(state -> state.method_11654(MultipartBlock.LUMINANCE))
        );

        BLOCK_ENTITY = FabricBlockEntityTypeBuilder.create(MultipartBlockEntity::new, BLOCK).build();
    }

    @Override
    public void onInitialize() {
        // For now always register everything
        register(class_2378.field_11146, BLOCK, "container");
        register(class_2378.field_11137, BLOCK_ENTITY, "container");
    }

    private static <T> void register(class_2378<T> registry, T obj, String path) {
        class_2378.method_10230(registry, id(path), obj);
    }

    public static class_2960 id(String path) {
        return new class_2960(NAMESPACE, path);
    }
}
