/*
 * Copyright (c) 2019 AlexIIL
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */
package alexiil.mc.lib.multipart.impl;

import net.minecraft.class_1922;
import net.minecraft.class_2338;
import net.minecraft.class_2586;
import net.minecraft.class_2680;
import net.minecraft.class_3610;

/** A {@link class_1922} that is backed by a different {@link class_1922}, but returns a different {@link class_2680},
 * {@link class_3610}, and {@link class_2586} for a single {@link class_2338}. */
public final class SingleReplacementBlockView implements class_1922 {
    private final class_1922 real;
    private final class_2338 replacedPos;
    private final class_2680 replacedState;
    private final class_2586 replacedEntity;

    public SingleReplacementBlockView(class_1922 world, class_2338 replacedPos, class_2680 state) {
        this.real = world;
        this.replacedPos = replacedPos;
        this.replacedState = state;
        this.replacedEntity = null;
    }

    public SingleReplacementBlockView(
        class_1922 world, class_2338 replacedPos, class_2680 state, class_2586 blockEntity
    ) {
        this.real = world;
        this.replacedPos = replacedPos;
        this.replacedState = state;
        this.replacedEntity = blockEntity;
    }

    @Override
    public class_2586 method_8321(class_2338 pos) {
        return pos.equals(replacedPos) ? replacedEntity : real.method_8321(pos);
    }

    @Override
    public class_2680 method_8320(class_2338 pos) {
        return pos.equals(replacedPos) ? replacedState : real.method_8320(pos);
    }

    @Override
    public class_3610 method_8316(class_2338 pos) {
        return pos.equals(replacedPos) ? replacedState.method_26227() : real.method_8316(pos);
    }

    @Override
    public int method_31605() {
        return real.method_31605();
    }

    @Override
    public int method_31607() {
        return real.method_31607();
    }
}
