/*
 * Copyright (c) 2019 AlexIIL
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */
package alexiil.mc.lib.multipart.mixin.impl;

import java.util.List;
import net.minecraft.class_1937;
import net.minecraft.class_2586;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import alexiil.mc.lib.multipart.mixin.api.IUnloadableBlockEntity;

@Mixin(class_1937.class)
public class WorldMixin {

    @Shadow
    private List<class_2586> unloadedBlockEntities;

    @Inject(at = @At("HEAD"), method = { "tickBlockEntities()V" })
    public void tick(CallbackInfo ci) {
        for (class_2586 entity : unloadedBlockEntities) {
            if (entity instanceof IUnloadableBlockEntity) {
                ((IUnloadableBlockEntity) entity).onChunkUnload();
            }
        }
    }
}
